<?php

namespace FiloBlu\Newsletter\Helper;

class Data extends \Magento\Framework\App\Helper\AbstractHelper {

    public function getConfig($config_path, $section = 'filoblu_newsletter_section') {
        return $this->scopeConfig->getValue(
                        $section . '/' . $config_path, \Magento\Store\Model\ScopeInterface::SCOPE_STORE
        );
    }

    public function setPopupCookie() {

        $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
        $objectManager->get('FiloBlu\Newsletter\Cookie\Popup')
                ->set("subscribed", $this->getConfig("popup/cookie_lifetime"));
    }

    public function getPopupCookie() {
        $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
        return $objectManager->get('FiloBlu\Newsletter\Cookie\Popup')
                        ->get();
    }

    public function deletePopupCookie() {
        $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
        $objectManager->get('FiloBlu\Newsletter\Cookie\Popup')
                ->delete();
    }

    public function getPopupCookieName() {
        return \FiloBlu\Newsletter\Cookie\Popup::COOKIE_NAME;
    }

    public function getCurrentLocale() {
        $om = \Magento\Framework\App\ObjectManager::getInstance();
        $resolver = $om->get('Magento\Framework\Locale\Resolver');
        return $resolver->getLocale();
    }

    public function getCurrentWebsiteName() {
        $om = \Magento\Framework\App\ObjectManager::getInstance();
        return $om->get('Magento\Store\Model\StoreManagerInterface')->getWebsite()->getName();
    }

    public function setThankYouCookie($id) {

        $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
        $objectManager->get('FiloBlu\Newsletter\Cookie\ThankYou')
                ->set($id, "can_view");
    }

    public function getThankYouCookie($id) {
        $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
        return $objectManager->get('FiloBlu\Newsletter\Cookie\ThankYou')
                        ->get($id);
    }

    public function deleteThankYouCookie($id) {
        $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
        $objectManager->get('FiloBlu\Newsletter\Cookie\ThankYou')
                ->delete($id);
    }

    public function setPreConfirmCookie($id) {

        $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
        $objectManager->get('FiloBlu\Newsletter\Cookie\PreConfirm')
                ->set($id, "can_view");
    }

    public function getPreConfirmCookie($id) {
        $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
        return $objectManager->get('FiloBlu\Newsletter\Cookie\PreConfirm')
                        ->get($id);
    }

    public function deletePreConfirmCookie($id) {
        $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
        $objectManager->get('FiloBlu\Newsletter\Cookie\PreConfirm')
                ->delete($id);
    }

}
